// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Deletes the specified alarms. You can delete up to 100 alarms in one operation. However, this total can include no more
/// than one composite alarm. For example, you could delete 99 metric alarms and one composite alarms with one operation, but you can't
/// delete two composite alarms with one operation.</p>
/// <p>
/// In the event of an error, no alarms are
/// deleted.</p>
/// <note>
/// <p>It is possible to create a loop or cycle of composite alarms, where composite alarm A depends on composite alarm B, and
/// composite alarm B also depends on composite alarm A. In this scenario, you can't delete any composite alarm that is part of the cycle
/// because there is always still a composite alarm that depends on that alarm that you want to delete.</p>
/// <p>To get out of such a situation, you must
/// break the cycle by changing the rule of one of the composite alarms in the cycle to remove a dependency that creates the cycle. The simplest
/// change to make to break a cycle is to change the <code>AlarmRule</code> of one of the alarms to <code>False</code>. </p>
/// <p>Additionally, the evaluation of composite alarms stops if CloudWatch detects a cycle in the evaluation path.
/// </p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAlarms {
    _private: (),
}
impl DeleteAlarms {
    /// Creates a new builder-style object to manufacture [`DeleteAlarmsInput`](crate::input::DeleteAlarmsInput)
    pub fn builder() -> crate::input::delete_alarms_input::Builder {
        crate::input::delete_alarms_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAlarms {
    type Output =
        std::result::Result<crate::output::DeleteAlarmsOutput, crate::error::DeleteAlarmsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_alarms_error(response)
        } else {
            crate::operation_deser::parse_delete_alarms_response(response)
        }
    }
}

/// <p>Deletes the specified anomaly detection model from your account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAnomalyDetector {
    _private: (),
}
impl DeleteAnomalyDetector {
    /// Creates a new builder-style object to manufacture [`DeleteAnomalyDetectorInput`](crate::input::DeleteAnomalyDetectorInput)
    pub fn builder() -> crate::input::delete_anomaly_detector_input::Builder {
        crate::input::delete_anomaly_detector_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAnomalyDetector {
    type Output = std::result::Result<
        crate::output::DeleteAnomalyDetectorOutput,
        crate::error::DeleteAnomalyDetectorError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_anomaly_detector_error(response)
        } else {
            crate::operation_deser::parse_delete_anomaly_detector_response(response)
        }
    }
}

/// <p>Deletes all dashboards that you specify. You
/// can specify up to 100 dashboards to delete. If there is an error during this call, no dashboards are
/// deleted.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteDashboards {
    _private: (),
}
impl DeleteDashboards {
    /// Creates a new builder-style object to manufacture [`DeleteDashboardsInput`](crate::input::DeleteDashboardsInput)
    pub fn builder() -> crate::input::delete_dashboards_input::Builder {
        crate::input::delete_dashboards_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteDashboards {
    type Output = std::result::Result<
        crate::output::DeleteDashboardsOutput,
        crate::error::DeleteDashboardsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_dashboards_error(response)
        } else {
            crate::operation_deser::parse_delete_dashboards_response(response)
        }
    }
}

/// <p>Permanently deletes the specified Contributor Insights rules.</p>
/// <p>If you create a rule, delete it, and then re-create it with the same name, historical data from the first time
/// the rule was created might
/// not be available.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteInsightRules {
    _private: (),
}
impl DeleteInsightRules {
    /// Creates a new builder-style object to manufacture [`DeleteInsightRulesInput`](crate::input::DeleteInsightRulesInput)
    pub fn builder() -> crate::input::delete_insight_rules_input::Builder {
        crate::input::delete_insight_rules_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteInsightRules {
    type Output = std::result::Result<
        crate::output::DeleteInsightRulesOutput,
        crate::error::DeleteInsightRulesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_insight_rules_error(response)
        } else {
            crate::operation_deser::parse_delete_insight_rules_response(response)
        }
    }
}

/// <p>Permanently deletes the metric stream that you specify.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteMetricStream {
    _private: (),
}
impl DeleteMetricStream {
    /// Creates a new builder-style object to manufacture [`DeleteMetricStreamInput`](crate::input::DeleteMetricStreamInput)
    pub fn builder() -> crate::input::delete_metric_stream_input::Builder {
        crate::input::delete_metric_stream_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteMetricStream {
    type Output = std::result::Result<
        crate::output::DeleteMetricStreamOutput,
        crate::error::DeleteMetricStreamError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_metric_stream_error(response)
        } else {
            crate::operation_deser::parse_delete_metric_stream_response(response)
        }
    }
}

/// <p>Retrieves the history for the specified alarm. You can filter the results by date range or item type.
/// If an alarm name is not specified, the histories for either all metric alarms or all composite alarms are returned.</p>
/// <p>CloudWatch retains the history of an alarm even if you delete the alarm.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAlarmHistory {
    _private: (),
}
impl DescribeAlarmHistory {
    /// Creates a new builder-style object to manufacture [`DescribeAlarmHistoryInput`](crate::input::DescribeAlarmHistoryInput)
    pub fn builder() -> crate::input::describe_alarm_history_input::Builder {
        crate::input::describe_alarm_history_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAlarmHistory {
    type Output = std::result::Result<
        crate::output::DescribeAlarmHistoryOutput,
        crate::error::DescribeAlarmHistoryError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_alarm_history_error(response)
        } else {
            crate::operation_deser::parse_describe_alarm_history_response(response)
        }
    }
}

/// <p>Retrieves the specified alarms. You can filter the results by specifying a prefix for the alarm
/// name, the alarm state, or a prefix for any action.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAlarms {
    _private: (),
}
impl DescribeAlarms {
    /// Creates a new builder-style object to manufacture [`DescribeAlarmsInput`](crate::input::DescribeAlarmsInput)
    pub fn builder() -> crate::input::describe_alarms_input::Builder {
        crate::input::describe_alarms_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAlarms {
    type Output =
        std::result::Result<crate::output::DescribeAlarmsOutput, crate::error::DescribeAlarmsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_alarms_error(response)
        } else {
            crate::operation_deser::parse_describe_alarms_response(response)
        }
    }
}

/// <p>Retrieves the alarms for the specified metric. To
/// filter the results, specify a statistic, period, or unit.</p>
/// <p>This operation retrieves only standard alarms that are based on
/// the specified metric. It does not return alarms based on math expressions that
/// use the specified metric, or composite alarms that use the specified metric.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAlarmsForMetric {
    _private: (),
}
impl DescribeAlarmsForMetric {
    /// Creates a new builder-style object to manufacture [`DescribeAlarmsForMetricInput`](crate::input::DescribeAlarmsForMetricInput)
    pub fn builder() -> crate::input::describe_alarms_for_metric_input::Builder {
        crate::input::describe_alarms_for_metric_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAlarmsForMetric {
    type Output = std::result::Result<
        crate::output::DescribeAlarmsForMetricOutput,
        crate::error::DescribeAlarmsForMetricError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_alarms_for_metric_error(response)
        } else {
            crate::operation_deser::parse_describe_alarms_for_metric_response(response)
        }
    }
}

/// <p>Lists the anomaly detection models that you have created in your account. You can list all
/// models in your account or filter the results to only the models that are related to a
/// certain namespace, metric name, or metric dimension.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAnomalyDetectors {
    _private: (),
}
impl DescribeAnomalyDetectors {
    /// Creates a new builder-style object to manufacture [`DescribeAnomalyDetectorsInput`](crate::input::DescribeAnomalyDetectorsInput)
    pub fn builder() -> crate::input::describe_anomaly_detectors_input::Builder {
        crate::input::describe_anomaly_detectors_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAnomalyDetectors {
    type Output = std::result::Result<
        crate::output::DescribeAnomalyDetectorsOutput,
        crate::error::DescribeAnomalyDetectorsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_anomaly_detectors_error(response)
        } else {
            crate::operation_deser::parse_describe_anomaly_detectors_response(response)
        }
    }
}

/// <p>Returns a list of all the Contributor Insights rules in your account.</p>
/// <p>For more information about Contributor Insights, see
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/ContributorInsights.html">Using Contributor Insights to Analyze High-Cardinality Data</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeInsightRules {
    _private: (),
}
impl DescribeInsightRules {
    /// Creates a new builder-style object to manufacture [`DescribeInsightRulesInput`](crate::input::DescribeInsightRulesInput)
    pub fn builder() -> crate::input::describe_insight_rules_input::Builder {
        crate::input::describe_insight_rules_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeInsightRules {
    type Output = std::result::Result<
        crate::output::DescribeInsightRulesOutput,
        crate::error::DescribeInsightRulesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_insight_rules_error(response)
        } else {
            crate::operation_deser::parse_describe_insight_rules_response(response)
        }
    }
}

/// <p>Disables the actions for the specified alarms. When an alarm's actions are disabled, the
/// alarm actions do not execute when the alarm state changes.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DisableAlarmActions {
    _private: (),
}
impl DisableAlarmActions {
    /// Creates a new builder-style object to manufacture [`DisableAlarmActionsInput`](crate::input::DisableAlarmActionsInput)
    pub fn builder() -> crate::input::disable_alarm_actions_input::Builder {
        crate::input::disable_alarm_actions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DisableAlarmActions {
    type Output = std::result::Result<
        crate::output::DisableAlarmActionsOutput,
        crate::error::DisableAlarmActionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_disable_alarm_actions_error(response)
        } else {
            crate::operation_deser::parse_disable_alarm_actions_response(response)
        }
    }
}

/// <p>Disables the specified Contributor Insights rules. When rules are disabled, they do not analyze log groups and do
/// not incur costs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DisableInsightRules {
    _private: (),
}
impl DisableInsightRules {
    /// Creates a new builder-style object to manufacture [`DisableInsightRulesInput`](crate::input::DisableInsightRulesInput)
    pub fn builder() -> crate::input::disable_insight_rules_input::Builder {
        crate::input::disable_insight_rules_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DisableInsightRules {
    type Output = std::result::Result<
        crate::output::DisableInsightRulesOutput,
        crate::error::DisableInsightRulesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_disable_insight_rules_error(response)
        } else {
            crate::operation_deser::parse_disable_insight_rules_response(response)
        }
    }
}

/// <p>Enables the actions for the specified alarms.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct EnableAlarmActions {
    _private: (),
}
impl EnableAlarmActions {
    /// Creates a new builder-style object to manufacture [`EnableAlarmActionsInput`](crate::input::EnableAlarmActionsInput)
    pub fn builder() -> crate::input::enable_alarm_actions_input::Builder {
        crate::input::enable_alarm_actions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for EnableAlarmActions {
    type Output = std::result::Result<
        crate::output::EnableAlarmActionsOutput,
        crate::error::EnableAlarmActionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_enable_alarm_actions_error(response)
        } else {
            crate::operation_deser::parse_enable_alarm_actions_response(response)
        }
    }
}

/// <p>Enables the specified Contributor Insights rules. When rules are enabled, they immediately begin analyzing log data.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct EnableInsightRules {
    _private: (),
}
impl EnableInsightRules {
    /// Creates a new builder-style object to manufacture [`EnableInsightRulesInput`](crate::input::EnableInsightRulesInput)
    pub fn builder() -> crate::input::enable_insight_rules_input::Builder {
        crate::input::enable_insight_rules_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for EnableInsightRules {
    type Output = std::result::Result<
        crate::output::EnableInsightRulesOutput,
        crate::error::EnableInsightRulesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_enable_insight_rules_error(response)
        } else {
            crate::operation_deser::parse_enable_insight_rules_response(response)
        }
    }
}

/// <p>Displays the details of the dashboard that you specify.</p>
/// <p>To copy an existing dashboard, use <code>GetDashboard</code>, and then use the data returned
/// within <code>DashboardBody</code> as the template for the new dashboard when you call <code>PutDashboard</code> to create
/// the copy.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetDashboard {
    _private: (),
}
impl GetDashboard {
    /// Creates a new builder-style object to manufacture [`GetDashboardInput`](crate::input::GetDashboardInput)
    pub fn builder() -> crate::input::get_dashboard_input::Builder {
        crate::input::get_dashboard_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetDashboard {
    type Output =
        std::result::Result<crate::output::GetDashboardOutput, crate::error::GetDashboardError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_dashboard_error(response)
        } else {
            crate::operation_deser::parse_get_dashboard_response(response)
        }
    }
}

/// <p>This operation returns the time series data collected by a Contributor Insights rule. The data includes the identity and number of
/// contributors to the log group.</p>
/// <p>You can also optionally return one or more statistics about each data point in the time series. These statistics can include the following:</p>
/// <ul>
/// <li>
/// <p>
/// <code>UniqueContributors</code> -- the number of unique contributors for each data point.</p>
/// </li>
/// <li>
/// <p>
/// <code>MaxContributorValue</code> -- the value of the top contributor for each data point. The identity of the
/// contributor might change for each data point in the graph.</p>
/// <p>If this rule aggregates by COUNT, the top contributor for each data point is the contributor with the
/// most occurrences in that period. If the rule aggregates by SUM, the top contributor is the contributor with the highest sum in the log field specified
/// by the rule's <code>Value</code>, during that period.</p>
/// </li>
/// <li>
/// <p>
/// <code>SampleCount</code> -- the number of data points matched by the rule.</p>
/// </li>
/// <li>
/// <p>
/// <code>Sum</code> -- the sum of the values from all contributors during the time period represented by that data point.</p>
/// </li>
/// <li>
/// <p>
/// <code>Minimum</code> -- the minimum value from a single observation during the time period represented by that data point.</p>
/// </li>
/// <li>
/// <p>
/// <code>Maximum</code> -- the maximum value from a single observation during the time period represented by that data point.</p>
/// </li>
/// <li>
/// <p>
/// <code>Average</code> -- the average value from all contributors during the time period represented by that data point.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetInsightRuleReport {
    _private: (),
}
impl GetInsightRuleReport {
    /// Creates a new builder-style object to manufacture [`GetInsightRuleReportInput`](crate::input::GetInsightRuleReportInput)
    pub fn builder() -> crate::input::get_insight_rule_report_input::Builder {
        crate::input::get_insight_rule_report_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetInsightRuleReport {
    type Output = std::result::Result<
        crate::output::GetInsightRuleReportOutput,
        crate::error::GetInsightRuleReportError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_insight_rule_report_error(response)
        } else {
            crate::operation_deser::parse_get_insight_rule_report_response(response)
        }
    }
}

/// <p>You can use the <code>GetMetricData</code> API to retrieve as many as 500 different
/// metrics in a single request, with a total of as many as 100,800 data points. You can also
/// optionally perform math expressions on the values of the returned statistics, to create
/// new time series that represent new insights into your data. For example, using Lambda
/// metrics, you could divide the Errors metric by the Invocations metric to get an error
/// rate time series. For more information about metric math expressions, see <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/using-metric-math.html#metric-math-syntax">Metric Math Syntax and Functions</a> in the <i>Amazon CloudWatch User
/// Guide</i>.</p>
/// <p>Calls to the <code>GetMetricData</code> API have a different pricing structure than
/// calls to <code>GetMetricStatistics</code>. For more information about pricing, see
/// <a href="https://aws.amazon.com/cloudwatch/pricing/">Amazon CloudWatch Pricing</a>.</p>
/// <p>Amazon CloudWatch retains metric data as follows:</p>
/// <ul>
/// <li>
/// <p>Data points with a period of less than 60 seconds are available for 3 hours. These data points are high-resolution
/// metrics and are available only for custom metrics that have been defined with a <code>StorageResolution</code> of 1.</p>
/// </li>
/// <li>
/// <p>Data points with a period of 60 seconds (1-minute) are available for 15 days.</p>
/// </li>
/// <li>
/// <p>Data points with a period of 300 seconds (5-minute) are available for 63 days.</p>
/// </li>
/// <li>
/// <p>Data points with a period of 3600 seconds (1 hour) are available for 455 days (15 months).</p>
/// </li>
/// </ul>
/// <p>Data points that are initially published with a shorter period are aggregated together for long-term storage. For example, if you collect
/// data using a period of 1 minute, the data remains available for 15 days with 1-minute resolution. After 15 days, this data is still available,
/// but is aggregated and retrievable only with a resolution of 5 minutes. After 63 days, the data is further aggregated and is available with
/// a resolution of 1 hour.</p>
/// <p>If you omit <code>Unit</code> in your request, all data that was collected with any unit is returned, along with the corresponding units that were specified
/// when the data was reported to CloudWatch. If you specify a unit, the operation returns only data that was collected with that unit specified.
/// If you specify a unit that does not match the data collected, the results of the operation are null. CloudWatch does not perform unit conversions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetMetricData {
    _private: (),
}
impl GetMetricData {
    /// Creates a new builder-style object to manufacture [`GetMetricDataInput`](crate::input::GetMetricDataInput)
    pub fn builder() -> crate::input::get_metric_data_input::Builder {
        crate::input::get_metric_data_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetMetricData {
    type Output =
        std::result::Result<crate::output::GetMetricDataOutput, crate::error::GetMetricDataError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_metric_data_error(response)
        } else {
            crate::operation_deser::parse_get_metric_data_response(response)
        }
    }
}

/// <p>Gets statistics for the specified metric.</p>
/// <p>The maximum number of data points returned from a single call is 1,440. If  
/// you request more than 1,440 data points, CloudWatch returns an error.
/// To reduce the number of data points, you can narrow the specified time range and make
/// multiple requests across adjacent time ranges, or you can increase the specified period.
/// Data points are not returned in chronological order.</p>
/// <p>CloudWatch aggregates data points based on the length of the period
/// that you specify. For example, if you request statistics with a one-hour period,
/// CloudWatch aggregates all data points with time stamps that fall within each
/// one-hour period. Therefore, the number of values aggregated by CloudWatch is larger than
/// the number of data points returned.</p>
/// <p>CloudWatch needs raw data points to calculate percentile statistics. If you publish
/// data using a statistic set instead, you can only retrieve
/// percentile statistics for this data if one of the following conditions is true:</p>
/// <ul>
/// <li>
/// <p>The SampleCount value of the statistic set is 1.</p>
/// </li>
/// <li>
/// <p>The Min and the Max values of the statistic set are equal.</p>
/// </li>
/// </ul>
/// <p>Percentile statistics are not available for metrics when any of the metric values are negative numbers.</p>
/// <p>Amazon CloudWatch retains metric data as follows:</p>
/// <ul>
/// <li>
/// <p>Data points with a period of less than 60 seconds are available for 3 hours. These data points are high-resolution
/// metrics and are available only for custom metrics that have been defined with a <code>StorageResolution</code> of 1.</p>
/// </li>
/// <li>
/// <p>Data points with a period of 60 seconds (1-minute) are available for 15 days.</p>
/// </li>
/// <li>
/// <p>Data points with a period of 300 seconds (5-minute) are available for 63 days.</p>
/// </li>
/// <li>
/// <p>Data points with a period of 3600 seconds (1 hour) are available for 455 days (15 months).</p>
/// </li>
/// </ul>
/// <p>Data points that are initially published with a shorter period are aggregated together for long-term storage. For example, if you collect
/// data using a period of 1 minute, the data remains available for 15 days with 1-minute resolution. After 15 days, this data is still available,
/// but is aggregated and retrievable only with a resolution of 5 minutes. After 63 days, the data is further aggregated and is available with
/// a resolution of 1 hour.</p>
/// <p>CloudWatch started retaining 5-minute and 1-hour metric data as of July 9, 2016.</p>  
/// <p>For information about metrics and dimensions supported by AWS services, see the
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CW_Support_For_AWS.html">Amazon CloudWatch Metrics and Dimensions Reference</a> in the
/// <i>Amazon CloudWatch User Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetMetricStatistics {
    _private: (),
}
impl GetMetricStatistics {
    /// Creates a new builder-style object to manufacture [`GetMetricStatisticsInput`](crate::input::GetMetricStatisticsInput)
    pub fn builder() -> crate::input::get_metric_statistics_input::Builder {
        crate::input::get_metric_statistics_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetMetricStatistics {
    type Output = std::result::Result<
        crate::output::GetMetricStatisticsOutput,
        crate::error::GetMetricStatisticsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_metric_statistics_error(response)
        } else {
            crate::operation_deser::parse_get_metric_statistics_response(response)
        }
    }
}

/// <p>Returns information about the metric stream that you specify.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetMetricStream {
    _private: (),
}
impl GetMetricStream {
    /// Creates a new builder-style object to manufacture [`GetMetricStreamInput`](crate::input::GetMetricStreamInput)
    pub fn builder() -> crate::input::get_metric_stream_input::Builder {
        crate::input::get_metric_stream_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetMetricStream {
    type Output = std::result::Result<
        crate::output::GetMetricStreamOutput,
        crate::error::GetMetricStreamError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_metric_stream_error(response)
        } else {
            crate::operation_deser::parse_get_metric_stream_response(response)
        }
    }
}

/// <p>You can use the <code>GetMetricWidgetImage</code> API to retrieve a snapshot graph of
/// one or more Amazon CloudWatch metrics as a bitmap image. You can then embed this
/// image into your services and products, such as wiki pages, reports, and documents.
/// You could also retrieve images regularly, such as every minute, and create your own
/// custom live dashboard.</p>
/// <p>The graph you retrieve can include all CloudWatch metric graph features, including metric math
/// and horizontal and vertical annotations.</p>
/// <p>There is a limit of 20 transactions per second for this API. Each <code>GetMetricWidgetImage</code> action has the following limits:</p>
/// <ul>
/// <li>
/// <p>As many as 100 metrics in the graph.</p>
/// </li>
/// <li>
/// <p>Up to 100 KB uncompressed payload.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetMetricWidgetImage {
    _private: (),
}
impl GetMetricWidgetImage {
    /// Creates a new builder-style object to manufacture [`GetMetricWidgetImageInput`](crate::input::GetMetricWidgetImageInput)
    pub fn builder() -> crate::input::get_metric_widget_image_input::Builder {
        crate::input::get_metric_widget_image_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetMetricWidgetImage {
    type Output = std::result::Result<
        crate::output::GetMetricWidgetImageOutput,
        crate::error::GetMetricWidgetImageError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_metric_widget_image_error(response)
        } else {
            crate::operation_deser::parse_get_metric_widget_image_response(response)
        }
    }
}

/// <p>Returns a list of the dashboards for your account. If you include <code>DashboardNamePrefix</code>, only
/// those dashboards with names starting with the prefix are listed. Otherwise, all dashboards in your account are
/// listed.
/// </p>
/// <p>
/// <code>ListDashboards</code> returns up to 1000 results on one page. If there
/// are more than 1000 dashboards, you can call <code>ListDashboards</code> again and
/// include the value you received for <code>NextToken</code> in the first call, to receive
/// the next 1000 results.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListDashboards {
    _private: (),
}
impl ListDashboards {
    /// Creates a new builder-style object to manufacture [`ListDashboardsInput`](crate::input::ListDashboardsInput)
    pub fn builder() -> crate::input::list_dashboards_input::Builder {
        crate::input::list_dashboards_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListDashboards {
    type Output =
        std::result::Result<crate::output::ListDashboardsOutput, crate::error::ListDashboardsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_dashboards_error(response)
        } else {
            crate::operation_deser::parse_list_dashboards_response(response)
        }
    }
}

/// <p>List the specified metrics. You can use the returned metrics with
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricData.html">GetMetricData</a> or
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricStatistics.html">GetMetricStatistics</a> to obtain statistical data.</p>
/// <p>Up to 500 results are returned for any one call. To retrieve additional results,
/// use the returned token with subsequent calls.</p>
/// <p>After you create a metric, allow up to 15 minutes before the metric appears.
/// You can see statistics about the metric sooner by using <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricData.html">GetMetricData</a> or
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricStatistics.html">GetMetricStatistics</a>.</p>
/// <p>
/// <code>ListMetrics</code> doesn't return information about metrics if those metrics haven't
/// reported data in the past two weeks. To retrieve those metrics, use
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricData.html">GetMetricData</a> or
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricStatistics.html">GetMetricStatistics</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListMetrics {
    _private: (),
}
impl ListMetrics {
    /// Creates a new builder-style object to manufacture [`ListMetricsInput`](crate::input::ListMetricsInput)
    pub fn builder() -> crate::input::list_metrics_input::Builder {
        crate::input::list_metrics_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListMetrics {
    type Output =
        std::result::Result<crate::output::ListMetricsOutput, crate::error::ListMetricsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_metrics_error(response)
        } else {
            crate::operation_deser::parse_list_metrics_response(response)
        }
    }
}

/// <p>Returns a list of metric streams in this account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListMetricStreams {
    _private: (),
}
impl ListMetricStreams {
    /// Creates a new builder-style object to manufacture [`ListMetricStreamsInput`](crate::input::ListMetricStreamsInput)
    pub fn builder() -> crate::input::list_metric_streams_input::Builder {
        crate::input::list_metric_streams_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListMetricStreams {
    type Output = std::result::Result<
        crate::output::ListMetricStreamsOutput,
        crate::error::ListMetricStreamsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_metric_streams_error(response)
        } else {
            crate::operation_deser::parse_list_metric_streams_response(response)
        }
    }
}

/// <p>Displays the tags associated with a CloudWatch resource. Currently, alarms
/// and Contributor Insights rules support tagging.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListTagsForResource {
    _private: (),
}
impl ListTagsForResource {
    /// Creates a new builder-style object to manufacture [`ListTagsForResourceInput`](crate::input::ListTagsForResourceInput)
    pub fn builder() -> crate::input::list_tags_for_resource_input::Builder {
        crate::input::list_tags_for_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListTagsForResource {
    type Output = std::result::Result<
        crate::output::ListTagsForResourceOutput,
        crate::error::ListTagsForResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_tags_for_resource_error(response)
        } else {
            crate::operation_deser::parse_list_tags_for_resource_response(response)
        }
    }
}

/// <p>Creates an anomaly detection model for a CloudWatch metric. You can use the model
/// to display a band of expected normal values when the metric is graphed.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch_Anomaly_Detection.html">CloudWatch Anomaly Detection</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutAnomalyDetector {
    _private: (),
}
impl PutAnomalyDetector {
    /// Creates a new builder-style object to manufacture [`PutAnomalyDetectorInput`](crate::input::PutAnomalyDetectorInput)
    pub fn builder() -> crate::input::put_anomaly_detector_input::Builder {
        crate::input::put_anomaly_detector_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutAnomalyDetector {
    type Output = std::result::Result<
        crate::output::PutAnomalyDetectorOutput,
        crate::error::PutAnomalyDetectorError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_anomaly_detector_error(response)
        } else {
            crate::operation_deser::parse_put_anomaly_detector_response(response)
        }
    }
}

/// <p>Creates or updates a <i>composite alarm</i>. When you create a composite
/// alarm, you specify a rule expression for the alarm that takes into account the alarm
/// states of other alarms that you have created. The composite alarm goes into ALARM state
/// only if all conditions of the rule are met.</p>
/// <p>The alarms specified in a composite alarm's rule expression can include metric alarms
/// and other composite alarms.</p>
/// <p>Using composite alarms can reduce
/// alarm noise. You can create multiple metric alarms,
/// and also create a composite alarm and
/// set up alerts only
/// for the composite alarm. For example, you could create a composite
/// alarm that goes into ALARM state only when more than one of the underlying metric alarms
/// are in ALARM state.</p>
/// <p>Currently, the only alarm actions that can be taken by composite alarms are notifying
/// SNS topics.</p>
/// <note>
/// <p>It is possible to create a loop or cycle of composite alarms, where composite alarm A depends on composite alarm B, and
/// composite alarm B also depends on composite alarm A. In this scenario, you can't delete any composite alarm that is part of the cycle
/// because there is always still a composite alarm that depends on that alarm that you want to delete.</p>
/// <p>To get out of such a situation, you must
/// break the cycle by changing the rule of one of the composite alarms in the cycle to remove a dependency that creates the cycle. The simplest
/// change to make to break a cycle is to change the <code>AlarmRule</code> of one of the alarms to <code>False</code>. </p>
/// <p>Additionally, the evaluation of composite alarms stops if CloudWatch detects a cycle in the evaluation path.
/// </p>
/// </note>
/// <p>When this operation creates an alarm, the alarm state is immediately set to
/// <code>INSUFFICIENT_DATA</code>. The alarm is then evaluated and its state is set
/// appropriately. Any actions associated with the new state are then executed. For a
/// composite alarm, this initial time after creation is the only time that
/// the
/// alarm can be in <code>INSUFFICIENT_DATA</code> state.</p>
/// <p>When you update an existing alarm, its state is left unchanged, but the update
/// completely overwrites the previous configuration of the alarm.</p>
/// <p>If you are an IAM user, you must have <code>iam:CreateServiceLinkedRole</code> to create
/// a composite alarm that has Systems Manager OpsItem actions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutCompositeAlarm {
    _private: (),
}
impl PutCompositeAlarm {
    /// Creates a new builder-style object to manufacture [`PutCompositeAlarmInput`](crate::input::PutCompositeAlarmInput)
    pub fn builder() -> crate::input::put_composite_alarm_input::Builder {
        crate::input::put_composite_alarm_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutCompositeAlarm {
    type Output = std::result::Result<
        crate::output::PutCompositeAlarmOutput,
        crate::error::PutCompositeAlarmError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_composite_alarm_error(response)
        } else {
            crate::operation_deser::parse_put_composite_alarm_response(response)
        }
    }
}

/// <p>Creates a dashboard if it does not already exist, or updates an existing dashboard. If you update a dashboard,
/// the entire contents are replaced with what you specify here.</p>
/// <p>All dashboards in your account are global, not region-specific.</p>
/// <p>A simple way to create a dashboard using <code>PutDashboard</code> is to copy an
/// existing dashboard. To copy an existing dashboard using the console, you can load the dashboard
/// and then use the View/edit source command in the Actions menu to display the JSON  block
/// for that dashboard. Another way to copy a dashboard is to
/// use <code>GetDashboard</code>, and then use the data returned
/// within <code>DashboardBody</code> as the template for the new dashboard when you call <code>PutDashboard</code>.</p>
/// <p>When you create a dashboard with <code>PutDashboard</code>, a good practice is to
/// add a text widget at the top of the dashboard with a message that the dashboard was created by script and should
/// not be changed in the console. This message could also point console users to the location
/// of the <code>DashboardBody</code> script or the CloudFormation template used to create the
/// dashboard.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutDashboard {
    _private: (),
}
impl PutDashboard {
    /// Creates a new builder-style object to manufacture [`PutDashboardInput`](crate::input::PutDashboardInput)
    pub fn builder() -> crate::input::put_dashboard_input::Builder {
        crate::input::put_dashboard_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutDashboard {
    type Output =
        std::result::Result<crate::output::PutDashboardOutput, crate::error::PutDashboardError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_dashboard_error(response)
        } else {
            crate::operation_deser::parse_put_dashboard_response(response)
        }
    }
}

/// <p>Creates a Contributor Insights rule. Rules evaluate log events in a
/// CloudWatch Logs log group, enabling you to find contributor data for the log events in that log group. For more information,
/// see <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/ContributorInsights.html">Using Contributor Insights to Analyze High-Cardinality Data</a>.</p>
/// <p>If you create a rule, delete it, and then re-create it with the same name, historical data from the first time
/// the rule was created might not be available.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutInsightRule {
    _private: (),
}
impl PutInsightRule {
    /// Creates a new builder-style object to manufacture [`PutInsightRuleInput`](crate::input::PutInsightRuleInput)
    pub fn builder() -> crate::input::put_insight_rule_input::Builder {
        crate::input::put_insight_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutInsightRule {
    type Output =
        std::result::Result<crate::output::PutInsightRuleOutput, crate::error::PutInsightRuleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_insight_rule_error(response)
        } else {
            crate::operation_deser::parse_put_insight_rule_response(response)
        }
    }
}

/// <p>Creates or updates an alarm and associates it with the specified metric, metric math expression,
/// or anomaly detection model.</p>
/// <p>Alarms based on anomaly detection models cannot have Auto Scaling actions.</p>
/// <p>When this operation creates an alarm, the alarm state is immediately set to
/// <code>INSUFFICIENT_DATA</code>. The alarm is then evaluated and its state is set
/// appropriately. Any actions associated with the new state are then executed.</p>
/// <p>When you update an existing alarm, its state is left unchanged, but the
/// update completely overwrites the previous configuration of the alarm.</p>
/// <p>If you are an IAM user, you must have
/// Amazon EC2 permissions for some alarm operations:</p>
/// <ul>
/// <li>
/// <p>The <code>iam:CreateServiceLinkedRole</code> for all alarms with EC2 actions</p>
/// </li>
/// <li>
/// <p>The <code>iam:CreateServiceLinkedRole</code> to create an alarm
/// with Systems Manager OpsItem actions.</p>
/// </li>
/// </ul>
/// <p>The first time you create an alarm in the
/// AWS Management Console, the CLI, or by using the PutMetricAlarm API, CloudWatch
/// creates the necessary service-linked role for you. The service-linked roles
/// are called <code>AWSServiceRoleForCloudWatchEvents</code> and
/// <code>AWSServiceRoleForCloudWatchAlarms_ActionSSM</code>.
/// For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_terms-and-concepts.html#iam-term-service-linked-role">AWS service-linked role</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutMetricAlarm {
    _private: (),
}
impl PutMetricAlarm {
    /// Creates a new builder-style object to manufacture [`PutMetricAlarmInput`](crate::input::PutMetricAlarmInput)
    pub fn builder() -> crate::input::put_metric_alarm_input::Builder {
        crate::input::put_metric_alarm_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutMetricAlarm {
    type Output =
        std::result::Result<crate::output::PutMetricAlarmOutput, crate::error::PutMetricAlarmError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_metric_alarm_error(response)
        } else {
            crate::operation_deser::parse_put_metric_alarm_response(response)
        }
    }
}

/// <p>Publishes metric data points to Amazon CloudWatch. CloudWatch associates
/// the data points with the specified metric. If the specified metric does not exist,
/// CloudWatch creates the metric. When CloudWatch creates a metric, it can
/// take up to fifteen minutes for the metric to appear in calls to <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_ListMetrics.html">ListMetrics</a>.</p>
/// <p>You can publish either individual data points in the <code>Value</code> field, or
/// arrays of values and the number of times each value occurred during the period by using the
/// <code>Values</code> and <code>Counts</code> fields in the <code>MetricDatum</code> structure. Using
/// the <code>Values</code> and <code>Counts</code> method enables you to publish up to 150 values per metric
/// with one <code>PutMetricData</code> request, and
/// supports retrieving percentile statistics on this data.</p>
/// <p>Each <code>PutMetricData</code> request is limited to 40 KB in size for HTTP POST requests. You can
/// send a payload compressed by gzip. Each request
/// is also limited to no more than 20 different metrics.</p>
/// <p>Although the <code>Value</code> parameter accepts numbers of type
/// <code>Double</code>, CloudWatch rejects values that are either too small
/// or too large. Values must be in the range of -2^360 to 2^360. In addition, special values (for example, NaN, +Infinity,
/// -Infinity) are not supported.</p>
/// <p>You can use up to 10 dimensions per metric to further clarify what data the metric collects. Each dimension
/// consists of a Name and Value pair. For more information about specifying dimensions, see <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/publishingMetrics.html">Publishing Metrics</a> in the
/// <i>Amazon CloudWatch User Guide</i>.</p>
/// <p>You specify the time stamp to be associated with each data point. You can specify
/// time stamps that are as much as two weeks before the current date, and as much as 2 hours after
/// the current day and time.</p>
/// <p>Data points with time stamps from 24 hours ago or longer can take at least 48
/// hours to become available for <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricData.html">GetMetricData</a> or
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricStatistics.html">GetMetricStatistics</a> from the time they
/// are submitted. Data points with time stamps between 3 and 24 hours ago can take as much as 2 hours to become available
/// for for <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricData.html">GetMetricData</a> or
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_GetMetricStatistics.html">GetMetricStatistics</a>.</p>
/// <p>CloudWatch needs raw data points to calculate percentile statistics. If you publish
/// data using a statistic set instead, you can only retrieve
/// percentile statistics for this data if one of the following conditions is true:</p>
/// <ul>
/// <li>
/// <p>The <code>SampleCount</code> value of the statistic set is 1 and <code>Min</code>,
/// <code>Max</code>, and <code>Sum</code> are all equal.</p>
/// </li>
/// <li>
/// <p>The <code>Min</code> and
/// <code>Max</code> are equal, and <code>Sum</code> is equal to <code>Min</code>
/// multiplied by <code>SampleCount</code>.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutMetricData {
    _private: (),
}
impl PutMetricData {
    /// Creates a new builder-style object to manufacture [`PutMetricDataInput`](crate::input::PutMetricDataInput)
    pub fn builder() -> crate::input::put_metric_data_input::Builder {
        crate::input::put_metric_data_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutMetricData {
    type Output =
        std::result::Result<crate::output::PutMetricDataOutput, crate::error::PutMetricDataError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_metric_data_error(response)
        } else {
            crate::operation_deser::parse_put_metric_data_response(response)
        }
    }
}

/// <p>Creates or updates a metric stream. Metric streams can automatically stream CloudWatch metrics
/// to AWS destinations including
/// Amazon S3 and to many third-party solutions.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/Metric-Streams.html">
/// Using Metric Streams</a>.</p>
/// <p>To create a metric stream,
/// you must be logged on to an account that has the <code>iam:PassRole</code> permission
/// and either the <code>CloudWatchFullAccess</code>
/// policy or the <code>cloudwatch:PutMetricStream</code>
/// permission.</p>
/// <p>When you create or update a metric stream, you choose one of the following:</p>
/// <ul>
/// <li>
/// <p>Stream metrics from all metric namespaces in the account.</p>
/// </li>
/// <li>
/// <p>Stream metrics from all metric namespaces in the account, except
/// for the namespaces that you list in <code>ExcludeFilters</code>.</p>
/// </li>
/// <li>
/// <p>Stream metrics from only the metric namespaces that you list in
/// <code>IncludeFilters</code>.</p>
/// </li>
/// </ul>
/// <p>When you use <code>PutMetricStream</code> to create a new metric stream, the stream
/// is created in the <code>running</code> state. If you use it to update an existing stream,
/// the state of the stream is not changed.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutMetricStream {
    _private: (),
}
impl PutMetricStream {
    /// Creates a new builder-style object to manufacture [`PutMetricStreamInput`](crate::input::PutMetricStreamInput)
    pub fn builder() -> crate::input::put_metric_stream_input::Builder {
        crate::input::put_metric_stream_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutMetricStream {
    type Output = std::result::Result<
        crate::output::PutMetricStreamOutput,
        crate::error::PutMetricStreamError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_metric_stream_error(response)
        } else {
            crate::operation_deser::parse_put_metric_stream_response(response)
        }
    }
}

/// <p>Temporarily sets the state of an alarm for testing purposes. When the updated
/// state differs from the previous value, the action configured for
/// the appropriate state is invoked. For example, if your alarm is configured to send an
/// Amazon SNS message when an alarm is triggered, temporarily changing the alarm state to
/// <code>ALARM</code> sends an SNS message.</p>
/// <p>Metric alarms
/// returns to their actual state quickly, often within seconds. Because the metric alarm state change
/// happens quickly, it is typically only visible in the alarm's <b>History</b> tab in the Amazon CloudWatch console or through
/// <a href="https://docs.aws.amazon.com/AmazonCloudWatch/latest/APIReference/API_DescribeAlarmHistory.html">DescribeAlarmHistory</a>.</p>
/// <p>If you use <code>SetAlarmState</code> on a composite alarm, the composite alarm is not guaranteed to return
/// to its actual state. It
/// returns to its actual state only once any of its children alarms change state. It is also
/// reevaluated if you update its
/// configuration.</p>
/// <p>If an alarm triggers EC2 Auto Scaling policies or application Auto Scaling policies, you must include
/// information in the <code>StateReasonData</code> parameter to enable the policy to take the correct action.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetAlarmState {
    _private: (),
}
impl SetAlarmState {
    /// Creates a new builder-style object to manufacture [`SetAlarmStateInput`](crate::input::SetAlarmStateInput)
    pub fn builder() -> crate::input::set_alarm_state_input::Builder {
        crate::input::set_alarm_state_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetAlarmState {
    type Output =
        std::result::Result<crate::output::SetAlarmStateOutput, crate::error::SetAlarmStateError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_alarm_state_error(response)
        } else {
            crate::operation_deser::parse_set_alarm_state_response(response)
        }
    }
}

/// <p>Starts the streaming of metrics for one or more of your metric streams.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StartMetricStreams {
    _private: (),
}
impl StartMetricStreams {
    /// Creates a new builder-style object to manufacture [`StartMetricStreamsInput`](crate::input::StartMetricStreamsInput)
    pub fn builder() -> crate::input::start_metric_streams_input::Builder {
        crate::input::start_metric_streams_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StartMetricStreams {
    type Output = std::result::Result<
        crate::output::StartMetricStreamsOutput,
        crate::error::StartMetricStreamsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_start_metric_streams_error(response)
        } else {
            crate::operation_deser::parse_start_metric_streams_response(response)
        }
    }
}

/// <p>Stops the streaming of metrics for one or more of your metric streams.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StopMetricStreams {
    _private: (),
}
impl StopMetricStreams {
    /// Creates a new builder-style object to manufacture [`StopMetricStreamsInput`](crate::input::StopMetricStreamsInput)
    pub fn builder() -> crate::input::stop_metric_streams_input::Builder {
        crate::input::stop_metric_streams_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StopMetricStreams {
    type Output = std::result::Result<
        crate::output::StopMetricStreamsOutput,
        crate::error::StopMetricStreamsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_stop_metric_streams_error(response)
        } else {
            crate::operation_deser::parse_stop_metric_streams_response(response)
        }
    }
}

/// <p>Assigns one or more tags (key-value pairs) to the specified CloudWatch resource. Currently, the only CloudWatch resources that
/// can be tagged are alarms and Contributor Insights rules.</p>
/// <p>Tags can help you organize and categorize your resources. You can also use them to scope user
/// permissions by granting a user
/// permission to access or change only resources with certain tag values.</p>
/// <p>Tags don't have any semantic meaning to AWS and are interpreted strictly as strings of characters.</p>
/// <p>You can use the <code>TagResource</code> action with an alarm that already has tags. If you specify a new tag key for the alarm,
/// this tag is appended to the list of tags associated
/// with the alarm. If you specify a tag key that is already associated with the alarm, the new tag value that you specify replaces
/// the previous value for that tag.</p>
/// <p>You can associate as many as 50 tags with a CloudWatch resource.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagResource {
    _private: (),
}
impl TagResource {
    /// Creates a new builder-style object to manufacture [`TagResourceInput`](crate::input::TagResourceInput)
    pub fn builder() -> crate::input::tag_resource_input::Builder {
        crate::input::tag_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagResource {
    type Output =
        std::result::Result<crate::output::TagResourceOutput, crate::error::TagResourceError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_resource_error(response)
        } else {
            crate::operation_deser::parse_tag_resource_response(response)
        }
    }
}

/// <p>Removes one or more tags from the specified resource.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagResource {
    _private: (),
}
impl UntagResource {
    /// Creates a new builder-style object to manufacture [`UntagResourceInput`](crate::input::UntagResourceInput)
    pub fn builder() -> crate::input::untag_resource_input::Builder {
        crate::input::untag_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagResource {
    type Output =
        std::result::Result<crate::output::UntagResourceOutput, crate::error::UntagResourceError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_resource_error(response)
        } else {
            crate::operation_deser::parse_untag_resource_response(response)
        }
    }
}
