// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PutRecordOutput {}
impl std::fmt::Debug for PutRecordOutput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PutRecordOutput");
        formatter.finish()
    }
}
/// See [`PutRecordOutput`](crate::output::PutRecordOutput)
pub mod put_record_output {
    /// A builder for [`PutRecordOutput`](crate::output::PutRecordOutput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {}
    impl Builder {
        /// Consumes the builder and constructs a [`PutRecordOutput`](crate::output::PutRecordOutput)
        pub fn build(self) -> crate::output::PutRecordOutput {
            crate::output::PutRecordOutput {}
        }
    }
}
impl PutRecordOutput {
    /// Creates a new builder-style object to manufacture [`PutRecordOutput`](crate::output::PutRecordOutput)
    pub fn builder() -> crate::output::put_record_output::Builder {
        crate::output::put_record_output::Builder::default()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct GetRecordOutput {
    /// <p>The record you requested. A list of <code>FeatureValues</code>.</p>
    pub record: std::option::Option<std::vec::Vec<crate::model::FeatureValue>>,
}
impl std::fmt::Debug for GetRecordOutput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("GetRecordOutput");
        formatter.field("record", &self.record);
        formatter.finish()
    }
}
/// See [`GetRecordOutput`](crate::output::GetRecordOutput)
pub mod get_record_output {
    /// A builder for [`GetRecordOutput`](crate::output::GetRecordOutput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) record: std::option::Option<std::vec::Vec<crate::model::FeatureValue>>,
    }
    impl Builder {
        pub fn record(mut self, input: impl Into<crate::model::FeatureValue>) -> Self {
            let mut v = self.record.unwrap_or_default();
            v.push(input.into());
            self.record = Some(v);
            self
        }
        pub fn set_record(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::FeatureValue>>,
        ) -> Self {
            self.record = input;
            self
        }
        /// Consumes the builder and constructs a [`GetRecordOutput`](crate::output::GetRecordOutput)
        pub fn build(self) -> crate::output::GetRecordOutput {
            crate::output::GetRecordOutput {
                record: self.record,
            }
        }
    }
}
impl GetRecordOutput {
    /// Creates a new builder-style object to manufacture [`GetRecordOutput`](crate::output::GetRecordOutput)
    pub fn builder() -> crate::output::get_record_output::Builder {
        crate::output::get_record_output::Builder::default()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DeleteRecordOutput {}
impl std::fmt::Debug for DeleteRecordOutput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DeleteRecordOutput");
        formatter.finish()
    }
}
/// See [`DeleteRecordOutput`](crate::output::DeleteRecordOutput)
pub mod delete_record_output {
    /// A builder for [`DeleteRecordOutput`](crate::output::DeleteRecordOutput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {}
    impl Builder {
        /// Consumes the builder and constructs a [`DeleteRecordOutput`](crate::output::DeleteRecordOutput)
        pub fn build(self) -> crate::output::DeleteRecordOutput {
            crate::output::DeleteRecordOutput {}
        }
    }
}
impl DeleteRecordOutput {
    /// Creates a new builder-style object to manufacture [`DeleteRecordOutput`](crate::output::DeleteRecordOutput)
    pub fn builder() -> crate::output::delete_record_output::Builder {
        crate::output::delete_record_output::Builder::default()
    }
}

#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct BatchGetRecordOutput {
    /// <p>A list of Records you requested to be retrieved in batch.</p>
    pub records: std::option::Option<std::vec::Vec<crate::model::BatchGetRecordResultDetail>>,
    /// <p>A list of errors that have occured when retrieving a batch of Records.</p>
    pub errors: std::option::Option<std::vec::Vec<crate::model::BatchGetRecordError>>,
    /// <p>A unprocessed list of <code>FeatureGroup</code> names, with their corresponding <code>RecordIdentifier</code> value,
    /// and Feature name.</p>
    pub unprocessed_identifiers:
        std::option::Option<std::vec::Vec<crate::model::BatchGetRecordIdentifier>>,
}
impl std::fmt::Debug for BatchGetRecordOutput {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("BatchGetRecordOutput");
        formatter.field("records", &self.records);
        formatter.field("errors", &self.errors);
        formatter.field("unprocessed_identifiers", &self.unprocessed_identifiers);
        formatter.finish()
    }
}
/// See [`BatchGetRecordOutput`](crate::output::BatchGetRecordOutput)
pub mod batch_get_record_output {
    /// A builder for [`BatchGetRecordOutput`](crate::output::BatchGetRecordOutput)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) records:
            std::option::Option<std::vec::Vec<crate::model::BatchGetRecordResultDetail>>,
        pub(crate) errors: std::option::Option<std::vec::Vec<crate::model::BatchGetRecordError>>,
        pub(crate) unprocessed_identifiers:
            std::option::Option<std::vec::Vec<crate::model::BatchGetRecordIdentifier>>,
    }
    impl Builder {
        pub fn records(
            mut self,
            input: impl Into<crate::model::BatchGetRecordResultDetail>,
        ) -> Self {
            let mut v = self.records.unwrap_or_default();
            v.push(input.into());
            self.records = Some(v);
            self
        }
        pub fn set_records(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::BatchGetRecordResultDetail>>,
        ) -> Self {
            self.records = input;
            self
        }
        pub fn errors(mut self, input: impl Into<crate::model::BatchGetRecordError>) -> Self {
            let mut v = self.errors.unwrap_or_default();
            v.push(input.into());
            self.errors = Some(v);
            self
        }
        pub fn set_errors(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::BatchGetRecordError>>,
        ) -> Self {
            self.errors = input;
            self
        }
        pub fn unprocessed_identifiers(
            mut self,
            input: impl Into<crate::model::BatchGetRecordIdentifier>,
        ) -> Self {
            let mut v = self.unprocessed_identifiers.unwrap_or_default();
            v.push(input.into());
            self.unprocessed_identifiers = Some(v);
            self
        }
        pub fn set_unprocessed_identifiers(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::BatchGetRecordIdentifier>>,
        ) -> Self {
            self.unprocessed_identifiers = input;
            self
        }
        /// Consumes the builder and constructs a [`BatchGetRecordOutput`](crate::output::BatchGetRecordOutput)
        pub fn build(self) -> crate::output::BatchGetRecordOutput {
            crate::output::BatchGetRecordOutput {
                records: self.records,
                errors: self.errors,
                unprocessed_identifiers: self.unprocessed_identifiers,
            }
        }
    }
}
impl BatchGetRecordOutput {
    /// Creates a new builder-style object to manufacture [`BatchGetRecordOutput`](crate::output::BatchGetRecordOutput)
    pub fn builder() -> crate::output::batch_get_record_output::Builder {
        crate::output::batch_get_record_output::Builder::default()
    }
}
